-- Get objects from orxonox
thisscript:addObject("SpaceShip", "Player")
thisscript:addObject("CameraMan", "cameraManager")

-- The Pirates
thisscript:addObject("NPC", "Ragnar01")
thisscript:addObject("NPC", "Ragnar02")

thisscript:addObject("NPC", "Pirate01")
thisscript:addObject("NPC", "Pirate02")
thisscript:addObject("NPC", "Pirate03")
thisscript:addObject("NPC", "Pirate53")
thisscript:addObject("NPC", "Pirate54")

thisscript:addObject("NPC", "Pirate04")
thisscript:addObject("NPC", "Pirate05")
thisscript:addObject("NPC", "Pirate06")
thisscript:addObject("NPC", "Pirate56")
thisscript:addObject("NPC", "Pirate57")

thisscript:addObject("NPC", "Pirate07")
thisscript:addObject("NPC", "Pirate08")
thisscript:addObject("NPC", "Pirate09")
thisscript:addObject("NPC", "Pirate59")
thisscript:addObject("NPC", "Pirate49")
thisscript:addObject("NPC", "Pirate79")

-- The Noxons
thisscript:addObject("NPC", "Noxon01")
thisscript:addObject("NPC", "Noxon02")
thisscript:addObject("NPC", "Noxon03")
thisscript:addObject("NPC", "Noxon04")
thisscript:addObject("NPC", "Noxon05")
--thisscript:addObject("NPC", "Noxon06")
--thisscript:addObject("NPC", "Noxon07")
--thisscript:addObject("NPC", "Noxon08")
--thisscript:addObject("NPC", "Noxon09")
--thisscript:addObject("NPC", "Noxon10")
--thisscript:addObject("NPC", "Noxon11")
--thisscript:addObject("NPC", "Noxon12")

-- thisscript:addObjectAsName("GameWorld", "Mission 1", "gameWorld")

triggerInit = ScriptTrigger()
triggerInit:setScript("vs1.lua")
triggerInit:setFunction("init")
triggerInit:setActiveOnCreation(true)

-- Create the cutscene trigger
triggerCutscene = ScriptTrigger()
triggerCutscene:setScript("vs1.lua")
triggerCutscene:setFunction("startSequence")
triggerCutscene:setRadius(50)
triggerCutscene:setTarget("Player")
triggerCutscene:setAbsCoor(2300 , 0 , 0)
triggerCutscene:setDebugDraw(true)
triggerCutscene:setActiveOnCreation(false)

-- Create another cutscene trigger
triggerCutscene02 = ScriptTrigger()
triggerCutscene02:setScript("vs1.lua")
triggerCutscene02:setFunction("switchToOtherPirate")
triggerCutscene02:setActiveOnCreation(true)

-- Create another cutscene trigger
triggerCutscene03 = ScriptTrigger()
triggerCutscene03:setScript("vs1.lua")
triggerCutscene03:setFunction("surviver")
triggerCutscene03:setActiveOnCreation(true)

-- Create another cutscene trigger
triggerCutscene04 = ScriptTrigger()
triggerCutscene04:setScript("vs1.lua")
triggerCutscene04:setFunction("onNoxons")
triggerCutscene04:setActiveOnCreation(true)

-- Create the cool Ragnar trigger
triggerRagnar = ScriptTrigger()
triggerRagnar:setScript("vs1.lua")
triggerRagnar:setFunction("startRagnar")
triggerRagnar:setRadius(50)
triggerRagnar:setTarget("Player")
triggerRagnar:setAbsCoor(3600 , 0 , -15)
triggerRagnar:setDebugDraw(true)
triggerRagnar:setActiveOnCreation(false)

-- Create a great AI activater
triggerAI01 = ScriptTrigger()
triggerAI01:setScript("vs1.lua")
triggerAI01:setFunction("activateGroup1")
triggerAI01:setRadius(50)
triggerAI01:setTarget("Player")
triggerAI01:setAbsCoor(2600, 0, -10)
triggerAI01:setDebugDraw(true)
triggerAI01:setActiveOnCreation(false)

-- Create another great AI activater
triggerAI02 = ScriptTrigger()
triggerAI02:setScript("vs1.lua")
triggerAI02:setFunction("activateGroup2")
triggerAI02:setRadius(50)
triggerAI02:setTarget("Player")
triggerAI02:setAbsCoor(4900, 0, -45)
triggerAI02:setDebugDraw(true)
triggerAI02:setActiveOnCreation(false)

-- Create another great AI activater
triggerAI03 = ScriptTrigger()
triggerAI03:setScript("vs1.lua")
triggerAI03:setFunction("activateGroup3")
triggerAI03:setRadius(50)
triggerAI03:setTarget("Player")
triggerAI03:setAbsCoor(5850, 0, -170)
triggerAI03:setDebugDraw(true)
triggerAI03:setActiveOnCreation(false)

-- Create another great AI activater
triggerAI04 = ScriptTrigger()
triggerAI04:setScript("vs1.lua")
triggerAI04:setFunction("startRagnar2")
triggerAI04:setRadius(50)
triggerAI04:setTarget("Player")
triggerAI04:setAbsCoor(6500, 0, -400)
triggerAI04:setDebugDraw(true)
triggerAI04:setActiveOnCreation(false)

-- Global Variables
counter = 0
cutsceneRunning = false
cutscene2Running = false
cutsceneEnd = false
cutscene2End = false
bossFight = false
bossFightEnd = false
time = 0

-- init function
function init(timestep)
-- cameraManager:setCam("GameWorld-Camera")
cameraManager:atachCameraToWorldEntity("CameraOne", "NPC", "Pirate01")
cameraManager:atachCameraToWorldEntity("CameraTwo", "NPC", "Noxon01")
cameraManager:setRelCoor("CameraOne", 10, 8 , -5)
cameraManager:setRelCoor("CameraTwo", 10, 8 , 5)


Ragnar01:pause(true)

return true
end

function startSequence(timestep)

Player:pause(true)
cameraManager:setCam("CameraOne")
cutsceneRunning = true
return true
end

function switchToOtherPirate(timestep)

if cutsceneRunning then
counter = counter + timestep
end

if counter > 5 and counter < 6 then
cameraManager:atachCameraToWorldEntity("CameraOne", "NPC", "Pirate03")
cameraManager:setRelCoorSoft("CameraOne", 10, 8 , 5, 6)

end

if counter > 11 then
cutsceneEnd = true
Player:pause(false)
cameraManager:setCam("GameWorld-Camera")
end

return cutsceneEnd
end


function startRagnar(timestep)

Ragnar01:pause(false)
return true
end


function activateGroup1(timestep)

Pirate01:setAI(true)
Pirate02:setAI(true)
Pirate03:setAI(true)
Pirate53:setAI(true)
Pirate54:setAI(true)

return true
end


function activateGroup2(timestep)

Pirate04:setAI(true)
Pirate05:setAI(true)
Pirate06:setAI(true)
Pirate56:setAI(true)
Pirate57:setAI(true)

return true
end


function activateGroup3(timestep)

Pirate07:setAI(true)
Pirate08:setAI(true)
Pirate09:setAI(true)
Pirate59:setAI(true)
Pirate49:setAI(true)
Pirate79:setAI(true)

return true
end


function startRagnar2(timestep)

Ragnar02:setAI(true)
bossFight = true
cameraManager:setRelCoorSoft("GameWorld-Camera", -0.05, 120, 0)
Player:pause(true)
return true
end


function surviver(timestep)

if bossFight then
time = time + timestep
end

if time > 25 then
Ragnar02:setAI(false)
bossFight = false
bossFightEnd = true
end

return bossFightEnd
end


function onNoxons(timestep)

if bossFightEnd then
cameraManager:setCam("CameraTwo")
end


return cutscene2End
end


function ragnarBoom(timestep)
Ragnar01:destroy()
return true
end